#pragma once
#include "B4RDefines.h"
#include "SRF05.h"

    //~Version: 1.0 
    //~Author - 
    //~Libray from https://github.com/RobTillaart/SRF05

namespace B4R {
    //~shortname:SRF05
    class B4RSRF05
    {
        private:
            uint8_t backend[sizeof(SRF05)];
            SRF05* rcs;
        public: 
              //  CONSTRUCTORS
            void Initialize(byte trigger,byte echo,byte out);
              //  set configuration
            void setSpeedOfSound(double sos);                                   //#Meth
              //  get configuration
            double getSpeedOfSound();                                           //#Meth
              //  adjust timing
            bool setCorrectionFactor(double factor);                            //#Meth
             //  get timing
            double getCorrectionFactor();                                       //#Meth
              //  set operational mode
            void setModeSingle();                                               //#Meth
              //  set operational mode
            void setModeAverage(byte count);                                    //#Meth
              //  set operational mode
            void setModeMedian(byte count);                                     //#Meth
              //  set operational mode
            void setModeRunningAverage(double alpha);                           //#Meth
              //  get operational mode
            byte getOperationalMode();                                          //#Meth
              //  get distance
            uint32_t getTime();                                                 //#Meth
              //  get distance
            uint32_t getMillimeter();                                           //#Meth
              //  get distance
            double getCentimeter();                                             //#Meth
              //  get distance
            double getMeter();                                                  //#Meth
              //  get distance
            double getInch();                                                   //#Meth
              //  get distance
            double getFeet();                                                   //#Meth
              //  Experimental - calibration
            double determineSpeedOfSound(uint16_t count);
              //  Experimental - adjust trigger length 
              //  - gain is a few microseconds at best.
              //  - 10 microseconds is advised minimum
              //  - to be investigated.
            void setTriggerLength(byte length);                                 //#Meth
              //  Experimental - adjust trigger length 
              //  - gain is a few microseconds at best.
              //  - 10 microseconds is advised minimum
              //  - to be investigated.
            byte getTriggerLength();                                            //#Meth
              //  TIMING
            uint32_t lastTime();
    };
}
